/* (C) Copyright International Business Machines Corporation 23 January  */
/* 1990.  All Rights Reserved.  */
/*   */
/* See the file USERAGREEMENT distributed with this software for full  */
/* terms and conditions of use.  */
/* SCCS Info: @(#)Makefile	1.16 2/7/92 */

/* Source files */
PFILES =	stdio.p

/* Intermediate absprog objects */
AOFILES =	stdio.ao

/* Object modules */
PROCOBJS =	stdio.po
PROCOBJSZ =	stdio.po.Z

#include "includefile"

/* Load preparsed process modules, rather than parsing them directly */
PCOMENV =	PCOMnoparse=

/* Suffix rules to create a pre-parsed process module object (we also */
/* place .ao before .p in suffix rules so .ao files are used) */
.SUFFIXES:
.SUFFIXES:	.ao .p .pp .po $(SUFFIXES)
.p.ao:	$<
	$(ENV) $(HERMENV) $(HPARSE) $<
.ao.po:	$<
	$*

/* Only take compiled process modules from standard system library */
LOADPATH =	$(PROCDIR)
/* Definitions come from compiler support definitions directory and */
/* standard system library, but we also include the current directory */
/* for loading .ao files */
DEFPATH =	$(HROOT)/hermes/defs:$(DEFDIR):$(HROOT)/hermes/io

all: $(AOFILES) compileprocs
install: all
	cp $(PROCOBJS) $(PROCDIR)
	
chcode:
	$(CHCODECMD) $(PROCOBJS)
chcompile:
	$(CHCOMPILECMD) $(PROCOBJS)

/* dependencies */
stdio.po:	stdio.ao
stdio.ao:	stdio.p
stdio.p:	stdio.pp

/* directory cleanup */

clean::
	rm -f stdio.p 
