/* (C) Copyright International Business Machines Corporation 23 January  */
/* 1990.  All Rights Reserved.  */
/*   */
/* See the file USERAGREEMENT distributed with this software for full  */
/* terms and conditions of use.  */
/* SCCS Info: @(#)Makefile	1.17 2/7/92 */

PFILES =	cache.p objectcache.p defmodcache.p programcache.p
PROCOBJS =	cache.po objectcache.po defmodcache.po programcache.po
PROCOBJSZ =	cache.po.Z objectcache.po.Z defmodcache.po.Z programcache.po.Z
DEFOBJS	=	objectcache.do programcache.do defmodcache.do \
		objectcacheimp.do programcacheimp.do
DEFOBJSZ =	objectcache.do.Z programcache.do.Z defmodcache.do.Z \
		objectcacheimp.do.Z programcacheimp.do.Z

#include "includefile"

EXTRACPPFLAGS =	-Uunix

all: 	$(PFILES) compiledefs compileprocs
install: all
	cp cache.po $(PROCDIR)

chcode:
	$(CHCODECMD) cache
chcompile:
	$(CHCOMPILECMD) cache


cache.po: cache.p programcache.do objectcache.do \
		programcache.po objectcache.po
cache.p: cache.pp

programcache.po: programcache.p programcache.do programcacheimp.do \
		defmodcache.do defmodcache.po
programcache.p: cachemaster.pp
	$(CPP) $(HCPPFLAGS) -DPROGRAMCACHE cachemaster.pp programcache.p

objectcache.po: objectcache.p objectcache.do objectcacheimp.do
objectcache.p: cachemaster.pp
	$(CPP) $(HCPPFLAGS) -DOBJECTCACHE  cachemaster.pp objectcache.p

defmodcache.po: defmodcache.p defmodcache.do

clean::
	rm -f cache.p programcache.p objectcache.p
